// () 2004  
//      .

using System;

public class GapelleI2CModem
{
    public double PilotFrequency = 1500;
    public double PilotTime = 1.0;
    public double SCLFrequency = 5838;
    public double SDAFrequency = 4077;
    public double BitTime = 0.007;

    private static double f(double SamplingFrequency, double Frequency, int Position)
    {
        return System.Math.Sin((double)Position * Frequency * System.Math.PI * 2 / SamplingFrequency);
    }

    public double[] Wave(I2C.BusLines[] I2CBusData, double SamplingFrequency, double Amplitude)
    {
        int PilotSamples = (int)(SamplingFrequency * PilotTime);
        int SamplesPerBit = (int)(SamplingFrequency * BitTime);
        double[] Wave = new double [PilotSamples + SamplesPerBit * I2CBusData.Length];
        int i = 0;
        for (int k = 0; k < PilotSamples; k++, i++)
            Wave[i] = Amplitude * f(SamplingFrequency, PilotFrequency, i);
        foreach (I2C.BusLines BusLines in I2CBusData)
            for (int k = 0; k < SamplesPerBit; k++, i++)
            {
                double x = 0;
                if (BusLines.SCLLow)
                    x += Amplitude * f(SamplingFrequency, SCLFrequency, i);
                if (BusLines.SDALow)
                    x += Amplitude * f(SamplingFrequency, SDAFrequency, i);
                if (BusLines.SCLLow && BusLines.SDALow)
                    x /= 2;
                Wave[i] = x;
            }
        return Wave;
    }
}
