// () 2004  
//      .

using System;

public class I2C
{

    public class BusLines
    {
        public BusLines(bool SCLLow, bool SDALow)
        {
            this.SCLLow = SCLLow;
            this.SDALow = SDALow;
        }
        public bool SCLLow;
        public bool SDALow;
    };

    public static BusLines[] Data(byte[] Data)
    {
        BusLines[] BusData = new BusLines [2 + Data.Length * ((8 + 1) * 3) + 4];
        int i = 0;
        // Start condition.
        BusData[i++] = new BusLines(false, false);
        BusData[i++] = new BusLines(false, true);
        // Data.
        foreach (byte Byte in Data)
        {
            for (int j = 7; j >= -1; j--)
            {
                bool Bit; 
                if (j >= 0)
                    Bit = ((Byte >> j) & 1) == 1;
                else
                    Bit = true; // Acknowledge.
                BusData[i++] = new BusLines(true, BusData[i - 2].SDALow);
                BusData[i++] = new BusLines(true, !Bit);
                BusData[i++] = new BusLines(false, BusData[i - 2].SDALow);
            }
        }
        // Stop condition.
        BusData[i++] = new BusLines(true, BusData[i - 2].SDALow);
        BusData[i++] = new BusLines(true, true);
        BusData[i++] = new BusLines(false, true);
        BusData[i++] = new BusLines(false, false);
        return BusData;
    }

}
