// () 2004  
//      .

using System;

class Sample
{

    public static void CreateFile(string FileName, double Frequency, bool LockAfterLoad)
    {
        //      .
        const double ReferenceFrequency = 4000000.0;
        const ushort ReferenceDividerRatio = 40;

        TSA5059 TSA5059 = new TSA5059();
        //    .
        TSA5059.MainDividerRatio = (ulong)(Frequency / (ReferenceFrequency / ReferenceDividerRatio));
        TSA5059.ReferenceDividerRatio = ReferenceDividerRatio;
        TSA5059.P2 = LockAfterLoad;
        TSA5059.MA0 = true;
        TSA5059.MA1 = false;

        //   I2C .
        I2C.BusLines[] I2CBusData = I2C.Data(TSA5059.Data()); 

        GapelleI2CModem Modem = new GapelleI2CModem();

        // ***   I2C     ***

        // -   .
        //        ,
        //       .
        //   ,  PilotTime = 0
        Modem.PilotFrequency = 1500; //  - ().
        Modem.PilotTime = 1; //  - (). 

        Modem.SCLFrequency = 5838; //    SCL (,   L2C2).
        Modem.SDAFrequency = 4077; //    SDA (,   L1C1).
        Modem.BitTime = 0.007; //      (c,       ).

        // **********************************************************************
        
        const double SamplingFrequency = 22050; //    .
        const double Amplitude = 1000.0; // ,      (         ).

        //     .
        double[] Wave = Modem.Wave(I2CBusData, SamplingFrequency, Amplitude);

        //  .
        WAVFile.Create(new System.IO.FileStream(FileName, System.IO.FileMode.Create),
            SamplingFrequency, Wave, Amplitude);
    }

}
